

uses crt, serial, sysutils, parkabel;

// ----------------------------------------------------------------------------
//  Schrittmotorsteuerung
// ----------------------------------------------------------------------------

procedure setzen(wert : byte);
begin
  datenausgabe(wert);

    ausgang1(low);
    ausgang2(low);
    ausgang3(low);
    ausgang4(low);

    ausgang1(high);
    ausgang2(high);
    ausgang3(high);
    ausgang4(high);
end;

var position : integer = 0;

procedure links;
begin
  inc(position);

  case position and 3 of
    0: setzen(1);
    1: setzen(4);
    2: setzen(2);
    3: setzen(8);
  end;
end;

procedure rechts;
begin
  dec(position);

  case position and 3 of
    0: setzen(1);
    1: setzen(4);
    2: setzen(2);
    3: setzen(8);
  end;
end;

// ----------------------------------------------------------------------------
//  Schnittstelle zu Mecrisp-Stellaris
// ----------------------------------------------------------------------------

var

   tty : LongInt;
   ComPortName  : String;
   s,tmpstr,txt : String;
   ComOut,ComIn : String;
   ComPortNr    : integer;
   writecount   : integer;
   status       : LongInt;

   BitsPerSec   : LongInt;
   ByteSize     : Integer;
   Parity       : TParityType; { TParityType = (NoneParity, OddParity, EvenParity); }
   StopBits     : Integer;
   Flags        : TSerialFlags; { TSerialFlags = set of (RtsCtsFlowControl); }

   eingabe : string;
   readcount : integer;

   ErrorCode    : Integer;

   hinein : array[0..255] of byte;
  i : integer;

    log : text;

procedure datenpunkt;

begin

      s:= '( ' + inttostr(position) + ' )  $300000 maximum-einzeln ! 24 empfindlichkeit hex.' ;
      s:= s + #10; { LF }
      writecount := length(s);
      status := SerWrite(tty, s[1], writecount );
      serdrain(tty);
      // write('OUT '+s);


      readcount := serreadtimeout(tty, hinein, 255, 700);

      setlength(eingabe, readcount);
      for i := 1 to readcount do
      begin
        eingabe[i] := chr(hinein[i-1]);
      end;

      setlength(eingabe, readcount);
      write(eingabe);
      write(log, eingabe);
end;

begin

  if fileexists('Log.txt') then
  begin
    assign(log, 'Log.txt');
    append(log);
  end
  else
  begin
    assign(log, 'Log.txt');
    rewrite(log);
  end;

  tty := SerOpen('/dev/ttyACM0');

  Flags:= [ ]; // None
  SerSetParams(tty,115200,8,NoneParity,1,Flags);


  repeat

    datenpunkt;
    for i := 1 to 20 do
    begin
      rechts;
      delay(50);
    end;

   until position <= -1800;

   repeat
     links;
     writeln(position);
     delay(50);
   until position = 0;


  serclose(tty);
  close(log);
end.

