unit parkabel;

{ 12. November 2006:  Erweiterte Fassung mit allen Ausg�ngen }

{ Zur leichten Ansteurung von Testschaltungen mit dem bunten Kabel }
{ f�r Freepascal unter Linux }

{ Pinbelegung, Ansicht von oben: }

{      Nase [-]           }
{ D0 D1 D2 D3 D4 D5  D6 D7 }
{ E1 E2 E3 E4 E5 GND A1 A2 }

interface

const high = true;
       low = false;

      power : array[0..7] of byte = (1, 2, 4, 8, 16, 32, 64, 128);     

var steuer_aktuell : byte;
     daten_aktuell : byte;

function  byte2bin(zahl : byte) : string;
procedure ausgang1(zustand : boolean);
procedure ausgang2(zustand : boolean);
procedure ausgang3(zustand : boolean);
procedure ausgang4(zustand : boolean);
procedure datenausgabe(zustand : byte);

function eingang : byte;

function eingang1 : boolean;
function eingang2 : boolean;
function eingang3 : boolean;
function eingang4 : boolean;
function eingang5 : boolean;

implementation

uses x86;

const datenport  : word = $378;
      statusport : word = $379;
      steuerport : word = $37A;

function byte2bin(zahl : byte) : string;
var i : byte;
    h : string;
begin
  h := '';
  for i := 7 downto 0 do
    if (zahl and power[i]) = power[i] then h := h + '1'
                                      else h := h + '0';
  byte2bin := h;
end;


procedure ausgang1(zustand : boolean);
begin
  { Die Steuerausg�nge sind in der Schnittstelle inventiert,
    darum hier "umgekehrte" Wirkweise }
  { /Strobe, Pin 1 }
  if zustand
    then steuer_aktuell := steuer_aktuell and 254
    else steuer_aktuell := steuer_aktuell or 1;  
  writeportb(steuerport, steuer_aktuell);
end;

procedure ausgang2(zustand : boolean);
  { /Auto Feed, Pin 14 }
begin
  if zustand
    then steuer_aktuell := steuer_aktuell and 253
    else steuer_aktuell := steuer_aktuell or 2;
  writeportb(steuerport, steuer_aktuell);
end;

procedure ausgang3(zustand : boolean);
  { Reset, Pin 16 }
begin
  if zustand
    then steuer_aktuell := steuer_aktuell or 4
    else steuer_aktuell := steuer_aktuell and 251;
  writeportb(steuerport, steuer_aktuell);
end;

procedure ausgang4(zustand : boolean);
  { /Select, Pin 17 }
begin
  if zustand
    then steuer_aktuell := steuer_aktuell and 247
    else steuer_aktuell := steuer_aktuell or 8;
  writeportb(steuerport, steuer_aktuell);
end;

procedure datenausgabe(zustand : byte);
  { D0-D7, Pin 2-9 }
begin
  daten_aktuell := zustand;
  writeportb(datenport, zustand);
end;


function eingang : byte;
begin
  eingang := (readportb(statusport) xor $80) shr 3;
end;


function eingang1 : boolean;
  { /Error, Pin 15 }
begin
  eingang1 := (eingang and 1) = 1;
end;

function eingang2 : boolean;
  { /Select, Pin 13 }
begin
  eingang2 := (eingang and 2) = 2;
end;

function eingang3 : boolean;
  { /Paper Empty, Pin 12 }
begin
  eingang3 := (eingang and 4) = 4;
end;

function eingang4 : boolean;
  { /Acknowledge, Pin 10 }
begin
  eingang4 := (eingang and 8) = 8;
end;

function eingang5 : boolean;
  { Busy, Pin 11 }
begin
  eingang5 := (eingang and 16) = 16;
end;



begin
  { Berechtigungen holen }
  if fpioperm(datenport, 3, 1) <> 0 then
  begin
    writeln('Die Portzugriffe wurden nicht gestattet !');
    halt(1);
  end;

  { Beide Steuerausg�nge auf 0V schalten }
  steuer_aktuell := 0;
  ausgang1(low);
  ausgang2(low);

  ausgang3(low);
  ausgang4(low);

  { Alle Datenausg�nge auf 0V schalten }
  datenausgabe(0);
end.

